<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRemoveDriverPoiItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfRemoveDriverPoiItem extends AbstractStructArrayBase
{
    /**
     * The RemoveDriverPoiItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RemoveDriverPoiItem[]
     */
    public $RemoveDriverPoiItem;
    /**
     * Constructor method for ArrayOfRemoveDriverPoiItem
     * @uses ArrayOfRemoveDriverPoiItem::setRemoveDriverPoiItem()
     * @param \StructType\RemoveDriverPoiItem[] $removeDriverPoiItem
     */
    public function __construct(array $removeDriverPoiItem = array())
    {
        $this
            ->setRemoveDriverPoiItem($removeDriverPoiItem);
    }
    /**
     * Get RemoveDriverPoiItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RemoveDriverPoiItem[]|null
     */
    public function getRemoveDriverPoiItem()
    {
        return isset($this->RemoveDriverPoiItem) ? $this->RemoveDriverPoiItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRemoveDriverPoiItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRemoveDriverPoiItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRemoveDriverPoiItemForArrayConstraintsFromSetRemoveDriverPoiItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRemoveDriverPoiItemRemoveDriverPoiItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfRemoveDriverPoiItemRemoveDriverPoiItemItem instanceof \StructType\RemoveDriverPoiItem) {
                $invalidValues[] = is_object($arrayOfRemoveDriverPoiItemRemoveDriverPoiItemItem) ? get_class($arrayOfRemoveDriverPoiItemRemoveDriverPoiItemItem) : sprintf('%s(%s)', gettype($arrayOfRemoveDriverPoiItemRemoveDriverPoiItemItem), var_export($arrayOfRemoveDriverPoiItemRemoveDriverPoiItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RemoveDriverPoiItem property can only contain items of type \StructType\RemoveDriverPoiItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RemoveDriverPoiItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RemoveDriverPoiItem[] $removeDriverPoiItem
     * @return \ArrayType\ArrayOfRemoveDriverPoiItem
     */
    public function setRemoveDriverPoiItem(array $removeDriverPoiItem = array())
    {
        // validation for constraint: array
        if ('' !== ($removeDriverPoiItemArrayErrorMessage = self::validateRemoveDriverPoiItemForArrayConstraintsFromSetRemoveDriverPoiItem($removeDriverPoiItem))) {
            throw new \InvalidArgumentException($removeDriverPoiItemArrayErrorMessage, __LINE__);
        }
        if (is_null($removeDriverPoiItem) || (is_array($removeDriverPoiItem) && empty($removeDriverPoiItem))) {
            unset($this->RemoveDriverPoiItem);
        } else {
            $this->RemoveDriverPoiItem = $removeDriverPoiItem;
        }
        return $this;
    }
    /**
     * Add item to RemoveDriverPoiItem value
     * @throws \InvalidArgumentException
     * @param \StructType\RemoveDriverPoiItem $item
     * @return \ArrayType\ArrayOfRemoveDriverPoiItem
     */
    public function addToRemoveDriverPoiItem(\StructType\RemoveDriverPoiItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RemoveDriverPoiItem) {
            throw new \InvalidArgumentException(sprintf('The RemoveDriverPoiItem property can only contain items of type \StructType\RemoveDriverPoiItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RemoveDriverPoiItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RemoveDriverPoiItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RemoveDriverPoiItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RemoveDriverPoiItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RemoveDriverPoiItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RemoveDriverPoiItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RemoveDriverPoiItem
     */
    public function getAttributeName()
    {
        return 'RemoveDriverPoiItem';
    }
}
